using Helper;

namespace Zadatak06
{
    public partial class Form1 : Form
    {
        private Size panelSize = new Size(200, 200);
        // Panel? je nullabilni Panel (moze biti NULL)
        // vezano uz .NET >=5.0
        private Panel? lastAddedPanel;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnAddPanel_Click(object sender, EventArgs e)
        {
            Panel panel = new Panel
            {
                Size = panelSize,
                BackColor = Utility.GetRandomColor(),
                Location = Utility
                    .GetRandomLocationInParent(pnlContainer.Size, panelSize)
            };

            // Controls je kolekcija djece (kontrola)
            pnlContainer.Controls.Add(panel);
            panel.BringToFront();

            lastAddedPanel = panel;
        }

        private void btnAddButton_Click(object sender, EventArgs e)
        {
            if (lastAddedPanel == null)
            {
                return;
            }

            Button button = new Button
            {
                Text = "Makni me"
            };
            button.Location = Utility
                .GetRandomLocationInParent(lastAddedPanel.Size, button.Size);
            button.Click += RemoveButton;

            lastAddedPanel.Controls.Add(button);
            button.BringToFront();
        }

        private void RemoveButton(object? sender, EventArgs e)
        {
            Button? button = sender as Button;
            button?.Parent?.Controls.Remove(button);
        }

        private void btnRemoveAllPanels_Click(object sender, EventArgs e)
        {
            pnlContainer.Controls.Clear();
        }

        private void btnRemoveAllButtons_Click(object sender, EventArgs e)
        {
            foreach (Control control in pnlContainer.Controls)
            {
                if (control is Panel)
                {
                    control.Controls.Clear(); 
                }
            }
        }

        private void pnlContainer_Paint(object sender, PaintEventArgs e)
        {

        }
    }
}
